// Document javascript
var xmlFile = "exporter.xml";
var xmlDoc;
var xmlLoaded;
var ActiveXObject;

var xmlTab = new Array();
var xmlDistances = new Array();
var xmlSteps = new Array();
var stepsNum;
var distancesNum;
var distancesRecords = new Array();
var stepsRecords = new Array();


function generateXML(){
    var xmlString = '<?xml version="1.0" encoding="utf-8"?>\n';
    xmlString += '<healthRecords>\n';
    var newRecordDate;
    var oldRecordDate = "0";
    for(var i=distancesRecords.length-1; i>0 ; i--){
        newRecordDate = distancesRecords[i]["date"].getDate() + "-" + distancesRecords[i]["date"].getMonth() + "-" + distancesRecords[i]["date"].getFullYear();
        if(newRecordDate != oldRecordDate){
            if(oldRecordDate != "0"){
                xmlString += '  </record>\n';
            }
           oldRecordDate = newRecordDate;
            xmlString += '  <record date="' + newRecordDate + '">\n';
        }
        xmlString += '    <records>\n'
        xmlString += '      <recordId>' + i + '</recordId>\n';
        xmlString += '      <time>' + distancesRecords[i]["date"].getHours() + ":" + distancesRecords[i]["date"].getMinutes() + ":" + distancesRecords[i]["date"].getSeconds() + '</time>\n';
        xmlString += '      <duration>' + distancesRecords[i]["duration"] + '</duration>\n';
        xmlString += '      <distance>' + distancesRecords[i]["distance"] + '</distance>\n';
        xmlString += '      <steps>' + distancesRecords[i]["steps"] + '</steps>\n';
        xmlString += '    </records>\n';
    }
     xmlString += '  </record>\n';
    xmlString += '</healthRecords>\n';
    var blob = new Blob([xmlString], {type: "text/xml"});
    //var file = new File(xmlHealthDoc, "healthXml.xml", {type: "application/xml;charset=utf-8"});
    saveAs(blob, "healthXml.xml");
    document.body.innerHTML += "xml saved...<br/>";

    
}


function parseXml(){
    document.body.innerHTML += "parsing xml data...<br/>";
    var xmlRecords = xmlDoc.getElementsByTagName("Record");
    
    document.body.innerHTML += "total xml records: " + xmlRecords.length + "<br/>";
    
    for(var i=0; i<xmlRecords.length; i++){
        var xmlType = xmlRecords[i].getAttribute("type");
        if(xmlType == "HKQuantityTypeIdentifierStepCount"){
            xmlSteps.push(i);
        }else if(xmlType == "HKQuantityTypeIdentifierDistanceWalkingRunning"){
            xmlDistances.push(i);
        }
    }
    
    stepsNum = xmlSteps.length;
    distancesNum = xmlDistances.length;
    
    document.body.innerHTML += "total steps records: " + xmlSteps.length + "<br/>";
    document.body.innerHTML += "total distances records: " + xmlDistances.length + "<br/><br/>";
    document.body.innerHTML += "xml parsing...<br/>";
    
    if(stepsNum >= distancesNum){
        var totalRecords = distancesNum;
        var distancesRecordsId = 0;
        for(var j = totalRecords-1; j > 0; j--){ //totalRecords-1
            var recordId = xmlDistances[j];
            var parseDate = xmlRecords[recordId].getAttribute("startDate").split(/[-: ]/);
            var recordStartDate = new Date(parseDate[0], parseDate[1]-1, parseDate[2], parseDate[3], parseDate[4], parseDate[5]);
            parseDate = xmlRecords[recordId].getAttribute("endDate").split(/[-: ]/);
            var recordEndDate = new Date(parseDate[0], parseDate[1]-1, parseDate[2], parseDate[3], parseDate[4], parseDate[5]);
            var recordDate = recordStartDate;
            var recordDuration = Math.floor((recordEndDate - recordStartDate)/1000)
            var recordDistance = xmlRecords[recordId].getAttribute("value");
            
            var recordSteps;
            for(var k = 0; k < stepsNum; k++){
                if(xmlRecords[xmlSteps[k]].getAttribute("startDate") == xmlRecords[recordId].getAttribute("startDate") && xmlRecords[xmlSteps[k]].getAttribute("endDate") == xmlRecords[recordId].getAttribute("endDate") && xmlRecords[xmlSteps[k]].getAttribute("value") != "undefined"){
                    recordSteps = xmlRecords[xmlSteps[k]].getAttribute("value");
                    
                    distancesRecords[distancesRecordsId] = new Array();
                    distancesRecords[distancesRecordsId]["date"] = recordDate;
                    distancesRecords[distancesRecordsId]["duration"] = recordDuration;
                    distancesRecords[distancesRecordsId]["distance"] = recordDistance;
                    distancesRecords[distancesRecordsId]["steps"] = recordSteps;
                    
                    distancesRecordsId += 1;
                   
                }
            }
            
            //document.body.innerHTML += "record Date: " + recordDate.getDate() + "-" + recordDate.getMonth() + "-" + recordDate.getFullYear() + " / Duration (s): " + recordDuration + " / Distance (Km): " + recordDistance + " / Steps: " + recordSteps + "<br/>";
            
        }
    }else{
        var totalRecords = stepsNum;
        var stepsRecordsId = 0;
        for(var j = totalRecords-1; j > 0; j--){ //totalRecords-1
            var recordId = xmlSteps[j];
            var parseDate = xmlRecords[recordId].getAttribute("startDate").split(/[-: ]/);
            var recordStartDate = new Date(parseDate[0], parseDate[1]-1, parseDate[2], parseDate[3], parseDate[4], parseDate[5]);
            parseDate = xmlRecords[recordId].getAttribute("endDate").split(/[-: ]/);
            var recordEndDate = new Date(parseDate[0], parseDate[1]-1, parseDate[2], parseDate[3], parseDate[4], parseDate[5]);
            var recordDate = recordStartDate;
            var recordDuration = Math.floor((recordEndDate - recordStartDate)/1000)
            var recordDistance = xmlRecords[recordId].getAttribute("value");
            
            var recordDistances;
            for(var k = 0; k < stepsNum; k++){
                if(xmlRecords[xmlDistances[k]].getAttribute("startDate") == xmlRecords[recordId].getAttribute("startDate") && xmlRecords[xmlDistances[k]].getAttribute("endDate") == xmlRecords[recordId].getAttribute("endDate") && xmlRecords[xmlDistances[k]].getAttribute("value") != "undefined"){
                    recordDistances = xmlRecords[xmlDistances[k]].getAttribute("value");
                    
                    distancesRecords[stepsRecordsId] = new Array();
                    distancesRecords[stepsRecordsId]["date"] = recordDate;
                    distancesRecords[stepsRecordsId]["duration"] = recordDuration;
                    distancesRecords[stepsRecordsId]["distance"] = recordDistance;
                    distancesRecords[stepsRecordsId]["steps"] = recordSteps;
                    
                    stepsRecordsId += 1;
                   
                }
            }
        }
    }
    document.body.innerHTML += "xml generation...<br/>";
    generateXML();
}

function importXml(){
    var xmlhttp,
        ie;
    try {
        xmlhttp = new XMLHttpRequest();
        xmlhttp.open("GET", xmlFile, false);
        
    } catch (Exception) {
        ie = (typeof window.ActiveXObject !== 'undefined');
        
        if (ie) {
            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            xmlDoc.async = false;
            while (xmlDoc.readyState !== 4) {
                
            }
            xmlDoc.load(xmlFile);
            parseXml();
            xmlLoaded = true;
        } else {
            xmlDoc = document.implementation.createDocument("", "", null);
            xmlDoc.onload = parseXml();
            xmlDoc.load(xmlFile);
            xmlLoaded = true;
        }  
    }
    if (!xmlLoaded) {
		xmlhttp.setRequestHeader('Content-Type', 'text/xml');
		xmlhttp.send("");
		xmlDoc = xmlhttp.responseXML;
		parseXml();
		xmlLoaded = true;
	}
    
}


function initParsing(){
    document.body.innerHTML += "import xml data...<br/>";
    importXml();
}